/*--------------------------------*-C-*---------------------------------*
 * File:        bbsnet.c
 *----------------------------------------------------------------------*
 *
 * All portions of code are copyright by their respective author/s.
 * Copyright (C) Hong-Yi Du <HYD.bbs@bbs.yzu.edu.tw>
 * Copyright (C) crazykid <kids.bbs@bbs.yzu.edu.tw>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *---------------------------------------------------------------------*/

#include "bbsnet.h"

int main(int argc,char *argv[])
{
  u_char key;   
  char key_string[80];     

  my_array = NULL;
  rank_array = NULL;
  
  if(argc>1)
   strcpy(datafile,argv[1]);   
  else
   strcpy(datafile,DATAFILE);
     
  sprintf(bbs_book,"%s/%s",getenv("HOME"),BOOKFILE);

  printf( CLS );
  GOTOXY( 8, 5);
  printf( "iBBSNET "VER"j");

  init_bbsnet(); 
  
  show_file(WELCOME);
  GOTOXY( 22, 18 );
  printf( "ثe@ %d/%d Hbϥγsu",z,max_use);
  GOTOXY( 22, 19 ); 
  printf( "(1) C (2) ڪ̷R [2] ?\n" );
  read( 0, &z, 1 );
  if( z == 49 )
    mode = ALL;
  else
    mode = MY_BOOK;
  
  load_data();

  while(1)
  {
    print_screen();
    while(1)
    {
      key = 0;
      read( 0, &key, 1 );
      switch( key )
      {
        case 3: case 4: finish();
        case _KEY_TAB:
          current = time(0) % counter + 1;
          page = current / TOTAL + 1;
          print_screen();
          sleep(1);

          key = 255;
          
        case 'i': cursor_move(  0, -1 ); break;
        case 'k': cursor_move(  0,  1 ); break;
        case 'l': cursor_move(  1,  0 ); break;
        case 'j': cursor_move( -1,  0 ); break;
        case '/':

          GOTOXY( 1, 24 );
          for( z = 0; z < 80; z ++ ) printf( " " );
          GOTOXY( 1, 24 );
          printf( "пJnM䪺r: " );
          tempmodes = savemodes;
          tempmodes.c_cflag = ( tempmodes.c_cflag & ~PARENB & ~CSIZE ) | CS8;
          tempmodes.c_iflag &= ~ISTRIP;
          tcsetattr( 0, TCSAFLUSH, &tempmodes );
          fgets( buf_string, 35, stdin );
          tcsetattr( 0, TCSAFLUSH, &modes );
          buf_string[strlen( buf_string ) - 1] = 0;
          fflush(stdin);     
          strcpy(key_string,buf_string);
          search(1,buf_string);
          break;
        case 'p':
	case '[':
          search(-1,key_string);
          break;
        case 'n':
        case ']':
          search(1,key_string);
          break;
        case 32: case 48: case 49: case 50: case 51: case 52: case 53: case 54:
        case 55: case 56: case 57:
          if( key == 32 ) page = page % max_page + 1;
          else if( key == 48 ) page = 10;
          else page = key - 48;
          
          /* kids: ˬdX̤j page */
          if((mode == ALL) && (page > max_page)) {
           page=max_page;
           break;
          } 
          if((mode == MY_BOOK) && (page > MAX_MYPAGE)) {
           page=MAX_MYPAGE;
           break;
          }
          if( current % TOTAL ) current = TOTAL * page + current % TOTAL - TOTAL;
          else current = TOTAL * page;
          print_screen();
        break;

/* kids */

/* [J ڪ̷R */

        case 'A':
        case 'a': if(mode == ALL) {
                   add_book();
                   cursor_move(0,1); /* [J۰ʤU */
                  }
        	  break;
	case 'E':
	case 'e': 

#ifdef	ALLOW_EDIT_DATAFILE
		  if(mode == ALL) {
		    edit(datafile);
		  }
#endif
#ifdef	ALLOW_EDIT_BOOKFILE		   
		  if(mode == MY_BOOK) {
		    edit(BOOKFILE);
		  }
#endif
		  break;
	                 
/* q ڪ̷R h */
        case 'D':
        case 'd': if(mode == MY_BOOK)
                  if(counter) {
                   del_book();
                   print_screen();
                  }
		  break;
/* s */

        case 'S':
        case 's': if(mode == MY_BOOK) save_book();
                  break;

        case 'V':
        case 'v': view_flag^=1;
                  message();
                  break;
        
/*  C */
        case 'W':
        case 'w': if(mode == ALL) break;
                  if(del_flag) save_book();
                  mode = ALL;
                  page=last_page; 
                  current=last_current; 
                  load_data();
                  print_screen();
                  break;

/*  ڪ̷R */

        case 'U':
        case 'u': if(mode == MY_BOOK) break;
                  mode = MY_BOOK;
                  rank_flag=0;
                  if(rank_array) free(rank_array);
                  load_data();
                  last_page=page;
                  last_current=current;
                  page=current=1;
                  del_flag=0;
                  print_screen();
                  break;
                  
        case 'R':
        case 'r': if(mode == MY_BOOK) break;
                  rank_data();
                  print_screen();     
                  break;
                  
        case 'H':          
        case 'h': printf( CLS );
                  show_file(HELP);
                  pressanykey();
                  print_screen();
                  break;
        case 'q': finish(); 
        case 10: 
        case _KEY_ENTER:  
        	  /* kids: [JP_ip~su */
                  if( (current <= counter) 
                   && (*array[current].ip) ) key = 255; break;
        case _KEY_ESC:
          read( 0, &key, 1 );
          if( key == 91 || key == 79 )
          {
            read( 0, &key, 1 );
            if( key == _KEY_UP    ) cursor_move(  0, -1 );
            if( key == _KEY_DOWN  ) cursor_move(  0,  1 );
            if( key == _KEY_RIGHT ) cursor_move(  1,  0 );
            if( key == _KEY_LEFT  ) cursor_move( -1,  0 );
          }
      }
      if( key == 255 ) break;
    }
    printf( CLS );

#ifdef LOG
    time( &now );
    tm_buf3 = localtime( &now );
    sprintf( buf_string, "%-12.12s %-15.15s %02d/%02d/%02d %02d:%02d:%02d-",
    getenv( "USER" ), array[current].ip, tm_buf3 -> tm_year, tm_buf3 -> tm_mon + 1,
    tm_buf3 -> tm_mday, tm_buf3 -> tm_hour, tm_buf3 -> tm_min, tm_buf3 -> tm_sec );
#endif

    if(fork()) wait(( int * ) 0 );
    else if( *array[current].port )
    
/* kids:  telnet escapechar Asu */
/* kids: 20011026: [J ssh Mϥ DN su䴩 */
    {
      if (atoi(array[current].port) == SSH_PORT) 
        execl( SSH_CLIENT, "ssh", 
              use_dn ? array[current].domain : array[current].ip, 0 );
      else 
        execl( TELNET, TELNET, "-8", "-e","", 
              use_dn ? array[current].domain : array[current].ip,
              array[current].port, 0 );
    } else execl( TELNET, TELNET, "-8", "-e","",
              use_dn ? array[current].domain : array[current].ip,
              0 );

/* kids: [Jέp */
  
    if(shm_array != NULL) 
    if((shm_array[array[current].num].times++)>9999)
     shm_array[array[current].num].times=0;
    
        
#ifdef LOG
    time( &now );
    tm_buf3 = localtime( &now );
    sprintf( buf_string, "%s%02d:%02d:%02d\n",
    buf_string, tm_buf3 -> tm_hour, tm_buf3 -> tm_min, tm_buf3 -> tm_sec );
    write_log();
#endif

  }
}

/* flag:1  , flag:-1 e */

void search(char flag,char *key)
{

  if( current == counter && flag == 1) z = 1;
  else if( current == 1 && flag == -1) z = counter;
  else z = current + flag;
  while( z != current && !strstr( array[z].name, key )
         && !strstr( array[z].domain, key )
         && !strstr( array[z].ip, key ))
  if( z >= counter && flag == 1 ) z = 1; /* kids: patch */
  else if( z <= 1 && flag == -1 ) z = counter;
  else z += flag;

  if( z != current ) 
   page = ( current = z ) / (TOTAL+1) + 1; /* kids: patch */

  print_screen();
}          

void print_screen()
{
  printf( "%s%s", CLS, NORMAL );
  printf( "" );
  for( z = 0; z < ( NAME + 1 ) * COL / 2 - 1; z ++, printf( "" ));
  printf( "" );
  for( z = 2; z < ROW + 5; z ++ )
  {
    GOTOXY( 1, z );
    printf( "" );
    GOTOXY( ( NAME + 1 ) * COL + 1, z );
    printf( "" );
  }
  GOTOXY( 1, ROW + 2 );
  printf( "" );
  for( z = 0; z < ( NAME + 1 ) * COL / 2 - 1; z ++, printf( "w" ));
  printf( "" );
  GOTOXY( 1, ROW + 4 );
  printf( "" );
  for( z = 0; z < ( NAME + 1 ) * COL / 2 - 1; z ++, printf( "" ));
  printf( "" );
  for( y = NAME + 2; y < NAME + 3 + ( NAME + 1 ) * ( COL - 2 ); y += NAME + 1 )
  for( z = 2; z < ROW + 2; z ++ )
  {
    GOTOXY( y, z );
    printf( "x" );
  }
  for( z = NAME + 2; z < NAME + 3 + ( NAME + 1 ) * ( COL - 2 ); z += NAME + 1 )
  {
    GOTOXY( z, 1 );
    printf( "" );
    GOTOXY( z, ROW + 2 );
    printf( "r" );
  }
  for( z = page * TOTAL - TOTAL + 1; z < page * TOTAL + 1; z ++ )
  {
    cursor( z );
    GOTOXY( cursor_x, cursor_y );
    if( z > counter )
    {
      printf( NORMAL );
      SPACE;
    }
    else printf( "%s%-*.*s", GREEN, NAME - 1, NAME - 1, array[z].name );
  }
  cursor( current );
  GOTOXY( cursor_x, cursor_y );
  if( current > counter )
  {
    printf( YELLOW_BLUE );
    SPACE;
    printf( NORMAL );
  }
  else printf( "%s%-*.*s%s", YELLOW_BLUE, NAME - 1, NAME - 1, array[current].name, NORMAL );
  show_help();
  message();
}

void message()
{
  GOTOXY( 3, ROW + 3 );
  if( current > counter )
  for( z = 0; z < ( NAME + 1 ) * COL - 2; z ++, printf( " " ));
  else
  {
    printf( "%s%-*.*s%s,%s%-15.15s%s", RED, NAME + 1, NAME + 1,
    array[current].name, NORMAL, YELLOW, array[current].ip, NORMAL );
    if( array[current].domain[0] == 32 )
    printf( "                              " );
    else printf( ",%s%-*.*s%s", GREEN, 46 - NAME, 46 - NAME, array[current].domain, NORMAL );
    if(view_flag)
    printf( "%s%-5.4d%s" , YELLOW,shm_array[array[current].num].times,NORMAL );
    else    
    if( atoi( array[current].port ))
    printf( ",%s%-5.5s%s", BLUE, array[current].port, NORMAL );
    else
    printf( "      ");
  }
}

void cursor( u_short z )
{
  if( z % TOTAL )
  if( z % ROW )
  {
    cursor_x = ( z % TOTAL / ROW ) * ( NAME + 1 ) + 3;
    cursor_y = z % TOTAL % ROW + 1;
  }
  else
  {
    cursor_x = ( z % TOTAL / ROW - 1 ) * ( NAME + 1 ) + 3;
    cursor_y = ROW + 1;
  }
  else
  {
    cursor_x = ( NAME + 1 ) * ( COL - 1 ) + 3;
    cursor_y = ROW + 1;
  }
}

void cursor_move( char x, char y )
{
  cursor( current );
  GOTOXY( cursor_x, cursor_y );
  if( current > counter )
  {
    printf( NORMAL );
    SPACE;
  }
  else printf( "%s%-*.*s%s", GREEN, NAME - 1, NAME - 1, array[current].name, NORMAL );
  if( x == -1 ) {
    if( current % TOTAL <= ROW && current % TOTAL > 0 )
    current += ( COL - 1 ) * ROW;
    else current -= ROW; 
  }
  if( x == 1 ) { 
    if( current % TOTAL > ( COL - 1 ) * ROW || !( current % TOTAL ))
    current -= ( COL - 1 ) * ROW;
    else current += ROW; 
  }
  if( y == -1 ) { 
    if( current % ROW == 1 ) current += ROW - 1;
    else current -= 1; 
  }
  if( y == 1 ) { 
    if( current % ROW ) current += 1;
    else current -= ROW - 1;
  }
  cursor( current ); 
  GOTOXY( cursor_x, cursor_y );
  if( current > counter )
  {
    printf( YELLOW_BLUE );
    SPACE;
    printf( NORMAL );
  }
  else printf( "%s%-*.*s%s", YELLOW_BLUE, NAME - 1, NAME - 1, array[current].name, NORMAL );
  message();
}

void show_help()
{
    char buffer[110];
    
    GOTOXY( 1, 24 );

    sprintf(buffer,"%s%s[m[%4d] (%d/%d) ",
     mode ? "i[1;33;36mڪ̷R[mj[1;33m[D][S][W][V][/][Q]" :
     	    "i[1;33;35mC[mj[1;33m[A][U][V][R][/][Q]" ,
     rank_flag ? RED"[ƦC] " :
     		 BLUE"[H]\\DU",
     counter,page,
     mode ? MAX_MYPAGE : max_page);
    printf(buffer);
    printf(" [HYD/kids] v"VER);
   
}

void finish()
{
  if(del_flag && !rank_flag) save_book(); /* kids: ۰ʦs */ 
  
  tcsetattr( 0, TCSAFLUSH, &savemodes);

  _exit(0);
}

void add_book()
{
  fd1 = fopen(bbs_book,"a");

  fprintf(fd1,"%-19s  %-32s %-16s  %-5s\n",array[current].name,
            array[current].domain,array[current].ip, array[current].port);
          
  fclose(fd1);
}

void edit(char *file)
{
  if(fork()) wait(( int * ) 0 );
  else execl(EDITOR, EDITOR, file, 0);
  
  /* kids: s觹᭫sJ */

  if (mode == ALL) {
  
    shmctl( shmid, IPC_STAT, &shmseg );

    if (shmseg.shm_nattch == 1) {
      shmdt(shm_array);
      shm_flag = 0;
      if (shmctl(shmid, IPC_RMID, NULL) < 0) {   
        printf( YELLOW"LkQ SHM!\n" NORMAL);
        pressanykey();    
      } else init_shm();
    
    } else { 
  
      printf( YELLOW "䥦Hϥ bbsnet, ]LksO骺!\n" NORMAL);
      pressanykey();    
    }
    
  }
  
  load_data();
  print_screen();
}
void save_book()
{

  fd1 = fopen(bbs_book,"w");
  if (counter > 0)
  for(z=1;z<=counter;z++)
    fprintf(fd1,"%-19s  %-32s %-16s  %-5s\n",array[z].name,
            array[z].domain,array[z].ip, array[z].port);
  fclose(fd1);
  del_flag = 0; 
}

void del_book()
{
  
  memset(array[current].name,0,sizeof(*array));
  if(current!=counter) {
    for(z=current;z<counter;z++) 
      memcpy(array[z].name,array[z+1].name,sizeof(*array));
    memset(array[counter].name,0, sizeof(*array)); 
  }
  else if(current!=1)
   current--;
  counter--;
  del_flag=1; /* ܦRL */
}

int compare(const void *arg1,const void *arg2)
{
  struct data *buf1,*buf2;

  buf1 = (struct data *)arg1;
  buf2 = (struct data *)arg2;
  if((buf1->times) == (buf2->times)) return 0;
  if((buf1->times) < (buf2->times)) return 1;
  else return -1;
}

void rank_data()
{
  void *base;
  if(!rank_flag) {
   rankarray_size = max_page * TOTAL * sizeof( *array );
   rank_array = ( void * ) calloc( rankarray_size, 1 );
   if(!rank_array) {
    printf("\nMemory enough!!\n");
   }
   memcpy(rank_array[0].name,array[0].name,rankarray_size);
   array=rank_array;
   base=rank_array[1].name;   
   qsort(base,counter,sizeof(*array),compare); 
  } else {
   array=shm_array;
   free(rank_array);
   rank_array=NULL;
  }
  rank_flag^=1;  
}       
         
void load_data()
{
  if(!shm_flag) { 
   shm_array = ( void * ) shmat( shmid, 0, 0 );

/* kids: shmat ӭn\, U~Bz̦n} */

   if (shm_array < 0) {
     shm_array = NULL;
     shm_flag = 0;
   }
   shm_flag = 1; /* ܤwg shmat */  

  }    

  switch (mode)
  {
    case ALL:

/* kids: 2.7 No shm e, Aq DATAFILE sŪ */

    	    if(shm_flag) {
    	      
    	      if(!(shm_array[0].num > 0))    	    	
    	      if(!load_from_file(datafile,shm_array)) {
                printf("LkJƮ榡...\n");
     		pressanykey();
     		finish();
  	      }
  	      
  	    }
   	    array = shm_array;
   	    counter = array[0].num;
  	    break;
  	    
    case MY_BOOK:  
  	   
  	    if(!my_array) { 
    		my_array = ( void * ) calloc( myarray_size, 1 );
   		if(!my_array) exit(1);
            }
               
            bzero(my_array,myarray_size);

/* Y} BOOKFILE ɿ~N^ CҦ */

            if(!load_from_file(bbs_book,my_array)) {
    	        mode = ALL;
    		free(my_array);
    		my_array = NULL;
    		return load_data();
   		  
   	    }	
    	    array = my_array;
 	    break;
 	    
  }		    
}


inline char exist_dot(char *s)
{
  for(; *s != 0; s++)
    if (*s == '.') return 1;
  return 0; 
}

char * skip_space(char *p)
{
  
  for(; isspace(*p); p++) ;
  
  return p;

}

void analysis(char *str, struct data *buf)
{

  /* pGrꤤS dot, HDƦr}Y,  */
  if (!exist_dot(str) && !isdigit(*str))
  {
    /* 䴩L DN x, DN H '(' }YhL DN */
    if (*str != '(') strcpy(buf[counter].name, str);
    else strcpy(buf[counter].domain, str);
  }

  /* pGrꤤS dot, åHƦr}Y */
  if (!exist_dot(str) && isdigit(*str))
    strcpy(buf[counter].port, str);
    
  /* pGrꤤ dot, åHƦr}Y */
  if (exist_dot(str) && isdigit(*str))
    strcpy(buf[counter].ip, str);

  /* pGrꤤ dot, åHr}Y */
  if (exist_dot(str) && isalpha(*str))
    strcpy(buf[counter].domain, str);
  
}

char smart_load(char *filename, struct data *buf)
{

  int fd;
  char *start, *line, *line_end; 
  struct stat sb;
  char *delim = DELIMITER;
  
  fd = open(filename,O_RDONLY);
  fstat(fd, &sb);
  if (!sb.st_size) return 0; 
  start = (char *) mmap(NULL, sb.st_size, PROT_READ|PROT_WRITE, 
                        MAP_PRIVATE, fd, 0);
  if (start == MAP_FAILED)
    return -1;
  
  line = skip_space(start);
  counter = 1;
  do {
        
    line_end = strchr(line, '\n');   
    if (line_end != NULL) *line_end = 0;    
    
    if (*line != '#')
    { 
      line = strtok(line, delim);
      do {
        analysis(line, buf);
        line = strtok(NULL, delim);      
      } while(line != NULL);
      counter++;
    }
    
    line = skip_space(++line_end);   
  } while(line < (start + sb.st_size));

  counter--;  
  munmap(start, sb.st_size);
  close(fd);
  if (counter > 0) return 1;
  return 0;
}

/* kids: 2.5 gǤJѼ */
/* kids: 2.7 iܨϥ smart_load() */

char load_from_file(char *filename,struct data *buf)
{

#ifdef	SMART_LOAD

  if (!smart_load(filename, buf)) return 0;
  
#else

  char *token;     
  counter = 1;
  if((fd = open( filename, O_RDONLY )) == -1) /* kids: patch */
  {
    /*
    printf( "Lk} %s .\n", filename );
    */
    return 0;
  }
  
  for( z = 0; read( fd, &y, 1 ); )
  if( y != '\n' && z < 79 ) buf_string[z ++] = y;
  else
  {
    while( y != '\n' ) read( fd, &y, 1 );
    z = buf_string[z] = 0;
    if(( token = strtok( buf_string, DELIMITER )))
    {
      if( token[0] == '#' ) continue;
      strncpy( buf[counter].name, token, NAME + 1 );
    }
    else
    {
      if( token )
      {
        printf( "\a%s  %d  W Ʈ榡~.\n",
        strrchr( filename, '/' ) + 1, counter );
        has_error = 1;
      }
      continue;
    }
    if(( token = strtok( 0, DELIMITER )))
    strncpy( buf[counter].domain, token, 31 );
    else
    {
      printf( "\a%s  %d  domain name Ʈ榡~.\n",
      strrchr( filename, '/' ) + 1, counter );
      has_error = 1;
      continue;
    }
    if(( token = strtok( 0, DELIMITER )))
    strncpy( buf[counter].ip, token, 15 );
    else
    {
      printf( "\a%s  %d  IP Ʈ榡~.\n",
      strrchr( filename, '/' ) + 1, counter );
      has_error = 1;
      continue;
    }
    if(( token = strtok( 0, DELIMITER )) && token[0] != '#' )
    strncpy( buf[counter].port, token, 5 );

    counter ++;
      
    buf[counter].num=counter; /* kids */
    buf[counter].times=0;     /* έpk 0 */
           
  }
  counter --;
                                                           
  close( fd );

  if(has_error) return 0; /* kids */

#endif
  
/*  kids: O@hֵơ**/

  strcpy(buf[0].name,"BBSNET2");
  buf[0].num=counter;
  printf("Ok !\n");
  return 1;
}


void show_file(char *filename)
{
  char str[80];
 
  if((fd1=fopen(filename,"r"))) { 
   while(!feof(fd1) && fgets(str,80,fd1))  
    printf("%s",str);
   fclose(fd1);
  }
}

void pressanykey()
{
  GOTOXY(1,24);
  printf("@~....");
  getchar();
}


void sig_ignore(int sig)
{                        
 
}    

void init_shm()
{

  if(stat( datafile, &stat_data ) == -1)
  {
    printf( YELLOW" }Ҹ %s !\n" NORMAL, datafile);
    pressanykey();
    _exit(0);
  
  }
  
  max_use = MAX_USE;
    
/* kids:  DATAFILE jpMw@ɰOjp */
  
  max_page=(stat_data.st_size/(TOTAL*72))+1;  
  
  array_size = max_page * TOTAL * sizeof( *array );  
  myarray_size = MAX_MYBOOK * sizeof( *array );

  shmid = shmget( shm_key, array_size, 0 );
  if( shmid < 0 )
  if(( shmid = shmget( shm_key, array_size, IPC_CREAT | 0666 )) < 0 )
  {
    printf( "\nнTw kernel 䴩 SYSVIPC M ipcrm  bbsnet ҨϥΪ shm.\n" );
    pressanykey();
    _exit(0);
  }
  if( !shmctl( shmid, IPC_STAT, &shmseg ) && (z=shmseg.shm_nattch) >= max_use)    
  {
    printf( YELLOW" \n  Sorry! wFϥΤWAثeLkϥΡAйLǮɭԦA.\n");
    pressanykey();
    _exit(0);
  }


}
void init_bbsnet()
{  

  init_shm();
  
/* kids: 20011026: ] SIGINT, ϥΪ Ctrl+C ^ bbsnet */

  signal( SIGQUIT, finish );
  signal( SIGHUP,  finish );
  signal( SIGTERM, finish );
  signal( SIGINT,  sig_ignore );
  
  tm_buf1 = localtime( &stat_data.st_ctime );

  tcgetattr( 0, &modes );
  savemodes = modes;
  modes.c_cc[VMIN] = 1;
  modes.c_cc[VTIME] = 0;
  modes.c_lflag &= ~ICANON;
  modes.c_lflag &= ~( ECHO | ECHOE | ECHOK | ECHOKE );
  tcsetattr( 0, TCSAFLUSH, &modes );
  setbuf( stdout,( char * ) 0 );
 
}


#ifdef LOG
void write_log()
{
  if(( fd = open( LOGFILE, O_WRONLY | O_CREAT | O_APPEND, 0666 ))) {
    flock( fd, LOCK_SH );
    write( fd, buf_string, strlen( buf_string ));
    flock( fd, LOCK_UN );
    close( fd );
  }
}
#endif

